
# parsetab.py
# This file is automatically generated. Do not edit.
# pylint: disable=W,C,R
_tabversion = '3.10'

_lr_method = 'LALR'

_lr_signature = 'ALL ALLPATHS CHANGE DEGREE DELETE EDGE EDGES GRAPH LOAD MERGE NODE PATH PRINT REDO SAVE STATE STRING UNDO\n    prog : stmt_list\n    \n    stmt_list : stmt stmt_list\n              | stmt\n    \n    stmt : GRAPH label command\n         | DELETE STATE label\n         | DELETE GRAPH label\n         | SAVE label\n         | LOAD label\n         | MERGE label label label\n         | UNDO\n         | REDO\n    \n    command : NODE label\n    \n    command : EDGE label label\n    \n    command : CHANGE label label\n    \n    command : PRINT DEGREE label\n           | PRINT PATH label label\n           | PRINT ALLPATHS label label\n           | PRINT EDGES\n           | PRINT ALL\n    \n    label : STRING\n    '
    
_lr_action_items = {'GRAPH':([0,3,5,9,10,13,16,17,19,24,25,27,33,34,35,36,37,38,41,42,],[4,4,15,-10,-11,-20,-7,-8,-4,-5,-6,-12,-18,-19,-9,-13,-14,-15,-16,-17,]),'DELETE':([0,3,9,10,13,16,17,19,24,25,27,33,34,35,36,37,38,41,42,],[5,5,-10,-11,-20,-7,-8,-4,-5,-6,-12,-18,-19,-9,-13,-14,-15,-16,-17,]),'SAVE':([0,3,9,10,13,16,17,19,24,25,27,33,34,35,36,37,38,41,42,],[6,6,-10,-11,-20,-7,-8,-4,-5,-6,-12,-18,-19,-9,-13,-14,-15,-16,-17,]),'LOAD':([0,3,9,10,13,16,17,19,24,25,27,33,34,35,36,37,38,41,42,],[7,7,-10,-11,-20,-7,-8,-4,-5,-6,-12,-18,-19,-9,-13,-14,-15,-16,-17,]),'MERGE':([0,3,9,10,13,16,17,19,24,25,27,33,34,35,36,37,38,41,42,],[8,8,-10,-11,-20,-7,-8,-4,-5,-6,-12,-18,-19,-9,-13,-14,-15,-16,-17,]),'UNDO':([0,3,9,10,13,16,17,19,24,25,27,33,34,35,36,37,38,41,42,],[9,9,-10,-11,-20,-7,-8,-4,-5,-6,-12,-18,-19,-9,-13,-14,-15,-16,-17,]),'REDO':([0,3,9,10,13,16,17,19,24,25,27,33,34,35,36,37,38,41,42,],[10,10,-10,-11,-20,-7,-8,-4,-5,-6,-12,-18,-19,-9,-13,-14,-15,-16,-17,]),'$end':([1,2,3,9,10,11,13,16,17,19,24,25,27,33,34,35,36,37,38,41,42,],[0,-1,-3,-10,-11,-2,-20,-7,-8,-4,-5,-6,-12,-18,-19,-9,-13,-14,-15,-16,-17,]),'STRING':([4,6,7,8,13,14,15,18,20,21,22,26,28,29,30,31,32,39,40,],[13,13,13,13,-20,13,13,13,13,13,13,13,13,13,13,13,13,13,13,]),'STATE':([5,],[14,]),'NODE':([12,13,],[20,-20,]),'EDGE':([12,13,],[21,-20,]),'CHANGE':([12,13,],[22,-20,]),'PRINT':([12,13,],[23,-20,]),'DEGREE':([23,],[30,]),'PATH':([23,],[31,]),'ALLPATHS':([23,],[32,]),'EDGES':([23,],[33,]),'ALL':([23,],[34,]),}

_lr_action = {}
for _k, _v in _lr_action_items.items():
   for _x,_y in zip(_v[0],_v[1]):
      if not _x in _lr_action:  _lr_action[_x] = {}
      _lr_action[_x][_k] = _y
del _lr_action_items

_lr_goto_items = {'prog':([0,],[1,]),'stmt_list':([0,3,],[2,11,]),'stmt':([0,3,],[3,3,]),'label':([4,6,7,8,14,15,18,20,21,22,26,28,29,30,31,32,39,40,],[12,16,17,18,24,25,26,27,28,29,35,36,37,38,39,40,41,42,]),'command':([12,],[19,]),}

_lr_goto = {}
for _k, _v in _lr_goto_items.items():
   for _x, _y in zip(_v[0], _v[1]):
       if not _x in _lr_goto: _lr_goto[_x] = {}
       _lr_goto[_x][_k] = _y
del _lr_goto_items
_lr_productions = [
  ("S' -> prog","S'",1,None,None,None),
  ('prog -> stmt_list','prog',1,'p_prog','final_gram.py',12),
  ('stmt_list -> stmt stmt_list','stmt_list',2,'p_stmt_list','final_gram.py',19),
  ('stmt_list -> stmt','stmt_list',1,'p_stmt_list','final_gram.py',20),
  ('stmt -> GRAPH label command','stmt',3,'p_stmt','final_gram.py',30),
  ('stmt -> DELETE STATE label','stmt',3,'p_stmt','final_gram.py',31),
  ('stmt -> DELETE GRAPH label','stmt',3,'p_stmt','final_gram.py',32),
  ('stmt -> SAVE label','stmt',2,'p_stmt','final_gram.py',33),
  ('stmt -> LOAD label','stmt',2,'p_stmt','final_gram.py',34),
  ('stmt -> MERGE label label label','stmt',4,'p_stmt','final_gram.py',35),
  ('stmt -> UNDO','stmt',1,'p_stmt','final_gram.py',36),
  ('stmt -> REDO','stmt',1,'p_stmt','final_gram.py',37),
  ('command -> NODE label','command',2,'p_command_node','final_gram.py',61),
  ('command -> EDGE label label','command',3,'p_command_EDGE','final_gram.py',69),
  ('command -> CHANGE label label','command',3,'p_command_CHANGE','final_gram.py',77),
  ('command -> PRINT DEGREE label','command',3,'p_command_print','final_gram.py',85),
  ('command -> PRINT PATH label label','command',4,'p_command_print','final_gram.py',86),
  ('command -> PRINT ALLPATHS label label','command',4,'p_command_print','final_gram.py',87),
  ('command -> PRINT EDGES','command',2,'p_command_print','final_gram.py',88),
  ('command -> PRINT ALL','command',2,'p_command_print','final_gram.py',89),
  ('label -> STRING','label',1,'p_string','final_gram.py',96),
]
